$OpenBSD$
--- xbattbar.c.orig	Tue Apr  3 18:58:00 2012
+++ xbattbar.c	Tue Apr  3 18:58:04 2012
@@ -29,6 +29,9 @@ static char *ReleaseVersion="1.4.2";
 #include <sys/time.h>
 #include <signal.h>
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
 #include <unistd.h>
 #include <sys/file.h>
 #include <sys/ioctl.h>
@@ -339,7 +342,12 @@ void showdiagbox(void)
   int pixw, pixh;
   int boxw, boxh;
   char diagmsg[64];
+  char timemsg[64];
+  time_t now;
 
+  /* compose time and date message */
+  time(&now);
+  strftime(timemsg, 64, "%+", localtime(&now));
   /* compose diag message and calculate its size in pixels */
   sprintf(diagmsg,
          "AC %s-line: battery level is %d%%",
@@ -348,7 +356,7 @@ void showdiagbox(void)
   pixw = XTextWidth(fontp, diagmsg, strlen(diagmsg));
   pixh = fontp->ascent + fontp->descent;
   boxw = pixw + DiagXMergin * 2;
-  boxh = pixh + DiagYMergin * 2;
+  boxh = 2 * pixh + DiagYMergin * 3;
 
   /* create status window */
   if(winstat != -1) disposediagbox();
@@ -367,6 +375,10 @@ void showdiagbox(void)
              gcstat,
              DiagXMergin, fontp->ascent+DiagYMergin,
              diagmsg, strlen(diagmsg));
+  XDrawString(disp, winstat, gcstat,
+             boxw/2 - XTextWidth(fontp, timemsg, strlen(timemsg))/2,
+             2*fontp->ascent+2*DiagYMergin,
+             timemsg, strlen(timemsg));
 }
 
 void disposediagbox(void)
@@ -575,7 +587,7 @@ void battery_check(void)
 
 #endif /* __FreeBSD__ */
 
-#ifdef __NetBSD__
+#if defined(__NetBSD__) || defined(__OpenBSD__)
 
 #include <machine/apmvar.h>
 
